diff -r 2f6cfac9adde man/ChangeLog
--- a/man/ChangeLog	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/ChangeLog	Sat Feb 14 11:40:58 2015 -0500
@@ -1,5 +1,15 @@
+2015-02-14  Vin Shelton  <acs@xemacs.org>
+
+	* custom.texi:
+	* info.texi:
+	* term.texi:
+	* widget.texi:
+	* lispref/edebug-inc.texi:
+	* lispref/packaging.texi: Now support texinfo version 5.2 (patch
+	from Jerry James and Volker Zell).
+
 2015-01-29  Vin Shelton <acs@xemacs.org>
- 
+
 	* XEmacs 21.4.23 is released
 
 2013-01-02  Vin Shelton  <acs@xemacs.org>
diff -r 2f6cfac9adde man/custom.texi
--- a/man/custom.texi	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/custom.texi	Sat Feb 14 11:40:58 2015 -0500
@@ -60,7 +60,7 @@
 
 @node Declaring Groups, Declaring Variables, Top, Top
 @comment  node-name,  next,  previous,  up
-@section Declaring Groups
+@chapter Declaring Groups
 
 Use @code{defgroup} to declare new customization groups.
 
@@ -92,7 +92,7 @@
 
 @node Declaring Variables, Declaring Faces, Declaring Groups, Top
 @comment  node-name,  next,  previous,  up
-@section Declaring Variables
+@chapter Declaring Variables
 
 Use @code{defcustom} to declare user editable variables.
 
@@ -176,7 +176,7 @@
 
 @node Declaring Faces, Usage for Package Authors, Declaring Variables, Top
 @comment  node-name,  next,  previous,  up
-@section Declaring Faces
+@chapter Declaring Faces
 
 Faces are declared with @code{defface}.
 
@@ -228,7 +228,7 @@
 
 @node Usage for Package Authors, Utilities, Declaring Faces, Top
 @comment  node-name,  next,  previous,  up
-@section Usage for Package Authors
+@chapter Usage for Package Authors
 
 The recommended usage for the author of a typical emacs lisp package is
 to create one group identifying the package, and make all user options
@@ -244,7 +244,7 @@
 
 @node  Utilities, The Init File, Usage for Package Authors, Top
 @comment  node-name,  next,  previous,  up
-@section Utilities
+@chapter Utilities
 
 These utilities can come in handy when adding customization support.
 
@@ -276,7 +276,7 @@
 
 @node The Init File, Wishlist, Utilities, Top
 @comment  node-name,  next,  previous,  up
-@section The Init File
+@chapter The Init File
 
 Customizations are saved to the file specified by @code{custom-file}, as
 calls to @code{custom-set-variables} and @code{custom-set-faces}.
@@ -299,7 +299,7 @@
 
 @node Wishlist,  , The Init File, Top
 @comment  node-name,  next,  previous,  up
-@section Wishlist
+@chapter Wishlist
 
 @itemize @bullet
 @item
diff -r 2f6cfac9adde man/info.texi
--- a/man/info.texi	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/info.texi	Sat Feb 14 11:40:58 2015 -0500
@@ -542,6 +542,10 @@
 
 @c If a menu appears at the end of this node, remove it.
 @c It is an accident of the menu updating command.
+@c Except now texinfo5 insists on one
+@menu
+* Help-Cross:: Cross reference section
+@end menu
 
 @node Help-Cross,  ,  , Help-Adv
 @subsection The node reached by the cross reference in Info
diff -r 2f6cfac9adde man/lispref/edebug-inc.texi
--- a/man/lispref/edebug-inc.texi	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/lispref/edebug-inc.texi	Sat Feb 14 11:40:58 2015 -0500
@@ -1103,7 +1103,7 @@
 Here is a table of the possibilities for @var{specification} and how each
 directs processing of arguments.
 
-@table @bullet
+@table @code
 
 @item @code{t}
 All arguments are instrumented for evaluation.
diff -r 2f6cfac9adde man/lispref/packaging.texi
--- a/man/lispref/packaging.texi	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/lispref/packaging.texi	Sat Feb 14 11:40:58 2015 -0500
@@ -600,7 +600,7 @@
 Does most of the work.  Builds the elcs, infos at a minimum.
 @end table
 
-@subsection The targets that most people would be interested in would be:
+@section The targets that most people would be interested in would be:
 
 @itemize @bullet
 @item @code{all}
diff -r 2f6cfac9adde man/term.texi
--- a/man/term.texi	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/term.texi	Sat Feb 14 11:40:58 2015 -0500
@@ -4,7 +4,7 @@
 
 @titlepage
 @sp 6
-@center @titlefont(Notes about Emacs TERM Mode)
+@center @titlefont{Notes about Emacs TERM Mode}
 @end titlepage
 
 @ifinfo
diff -r 2f6cfac9adde man/widget.texi
--- a/man/widget.texi	Fri Feb 13 20:42:38 2015 -0500
+++ b/man/widget.texi	Sat Feb 14 11:40:58 2015 -0500
@@ -38,7 +38,7 @@
 
 @node  Introduction, User Interface, Top, Top
 @comment  node-name,  next,  previous,  up
-@section Introduction
+@chapter Introduction
 
 Most graphical user interface toolkits, such as Motif and XView, provide
 a number of standard user interface controls (sometimes known as